-- MySQL dump 9.08
--
-- Host: localhost    Database: grants_gov
---------------------------------------------------------
-- Server version	4.0.13-nt

--
-- Table structure for table 'sf424_attachment'
--

CREATE TABLE sf424_attachment (
  Grants_govTrackingNumber varchar(240) NOT NULL default '',
  FileName varchar(60) default '',
  FileMimeType varchar(30) default '',
  PRIMARY KEY  (Grants_govTrackingNumber)
) TYPE=MyISAM;

--
-- Dumping data for table 'sf424_attachment'
--


--
-- Table structure for table 'sf424_attachmentnarrative'
--

CREATE TABLE sf424_attachmentnarrative (
  Grants_govTrackingNumber varchar(240) NOT NULL default '',
  pageSequenceNumber int(11) default '0',
  NarrativePage longtext,
  PRIMARY KEY  (Grants_govTrackingNumber)
) TYPE=MyISAM;

--
-- Dumping data for table 'sf424_attachmentnarrative'
--


--
-- Table structure for table 'sf424a_budgetcategories'
--

CREATE TABLE sf424a_budgetcategories (
  BudgetCategoryIndex int(11) NOT NULL auto_increment,
  FormVersionIdentifier varchar(30) default '',
  Grants_govTrackingNumber varchar(240) default '',
  GrantActivity varchar(240) default '',
  BudgetPersonnelRequestedAmount float default '0',
  BudgetFringeBenefitsRequestedAmount float default '0',
  BudgetTravelRequestedAmount float default '0',
  BudgetEquipmentRequestedAmount float default '0',
  BudgetSuppliesRequestedAmount float default '0',
  BudgetContractualRequestedAmount float default '0',
  BudgetConstructionRequestedAmount float default '0',
  BudgetOtherRequestedAmount float default '0',
  BudgetTotalDirectChargesAmount float default '0',
  BudgetIndirectChargesAmount float default '0',
  BudgetTotalAmount float default '0',
  ProgramIncomeAmount float default '0',
  PRIMARY KEY  (BudgetCategoryIndex)
) TYPE=MyISAM;

--
-- Dumping data for table 'sf424a_budgetcategories'
--


--
-- Table structure for table 'sf424a_budgetsummary'
--

CREATE TABLE sf424a_budgetsummary (
  BudegetSummaryIndex int(11) NOT NULL auto_increment,
  FormVersionIdentifier varchar(30) default '',
  Grants_govTrackingNumber varchar(240) default '',
  GrantAcitivity varchar(100) default '',
  CFDANumber varchar(15) default '',
  BudgetFederalEstimatedUnobligatedAmount float default '0',
  BudgetNonFederalEstimatedUnobligatedAmount float default '0',
  BudgetFederalNewOrRevisedAmount float default '0',
  BudgetNonFederalNewOrRevisedAmount float default '0',
  BudgetTotalNewOrRevisedAmount float default '0',
  PRIMARY KEY  (BudegetSummaryIndex)
) TYPE=MyISAM;

--
-- Dumping data for table 'sf424a_budgetsummary'
--


--
-- Table structure for table 'sf424a_estimatfederalfundsneeded'
--

CREATE TABLE sf424a_estimatfederalfundsneeded (
  EstimateFederalFundsNeededIndex int(11) NOT NULL auto_increment,
  FormVersionIdentifier varchar(30) default '',
  Grants_govTrackingNumber varchar(240) default '',
  GrantAcitivity varchar(100) default '',
  BudgetFirstYearAmount float default '0',
  BudgetSecondYearAmount float default '0',
  BudgetThirdYearAmount float default '0',
  BudgetBudgetFourthYearAmount float default '0',
  PRIMARY KEY  (EstimateFederalFundsNeededIndex)
) TYPE=MyISAM;

--
-- Dumping data for table 'sf424a_estimatfederalfundsneeded'
--


--
-- Table structure for table 'sf424a_forecastedcashneeds'
--

CREATE TABLE sf424a_forecastedcashneeds (
  ForecastedCashNeedsIndex int(11) NOT NULL auto_increment,
  FormVersionIdentifier varchar(30) default '',
  Grants_govTrackingNumber varchar(240) default '',
  TimeFrame varchar(100) default '',
  BudgetFederalForecastedAmount float default '0',
  BudgetNonFederalForecastedAmount float default '0',
  BudgetTotalForecastedAmount float default '0',
  PRIMARY KEY  (ForecastedCashNeedsIndex)
) TYPE=MyISAM;

--
-- Dumping data for table 'sf424a_forecastedcashneeds'
--


--
-- Table structure for table 'sf424a_nonfederalresources'
--

CREATE TABLE sf424a_nonfederalresources (
  NonFederalResourcesIndex int(11) NOT NULL auto_increment,
  FormVersionIdentifier varchar(30) default '',
  Grants_govTrackingNumber varchar(240) default '',
  GrantActivity varchar(100) default '',
  BudgetApplicantContributionAmount float default '0',
  BudgetStateContributionAmount float default '0',
  BudgetOtherContributionAmount float default '0',
  BudgetTotalContributionAmount float default '0',
  PRIMARY KEY  (NonFederalResourcesIndex)
) TYPE=MyISAM;

--
-- Dumping data for table 'sf424a_nonfederalresources'
--


--
-- Table structure for table 'sf424a_otherinfo'
--

CREATE TABLE sf424a_otherinfo (
  OtherInfoIndex int(11) NOT NULL auto_increment,
  FormVersionIdentifier varchar(30) default '',
  Grants_govTrackingNumber varchar(240) default '',
  OtherDirectChargesExplanation varchar(100) default '',
  OtherIndirectChargesExplanation varchar(100) default '',
  Remarks varchar(250) default '',
  PRIMARY KEY  (OtherInfoIndex)
) TYPE=MyISAM;

--
-- Dumping data for table 'sf424a_otherinfo'
--


--
-- Table structure for table 'sf424b'
--

CREATE TABLE sf424b (
  TableIndex int(11) NOT NULL auto_increment,
  Grants_govTrackingNumber varchar(240) NOT NULL default '',
  FormVersionIdentifier varchar(30) default '',
  RepresentativeName varchar(30) default '',
  RepresentativeTitle varchar(45) default '',
  ApplicantOrganizationName varchar(60) default '',
  SubmittedDate date default '0000-00-00',
  ProgramType varchar(100) default '',
  PRIMARY KEY  (TableIndex)
) TYPE=MyISAM;

--
-- Dumping data for table 'sf424b'
--


--
-- Table structure for table 'sf424c_budgetinfo'
--

CREATE TABLE sf424c_budgetinfo (
  BudgetInfoIndex int(11) NOT NULL auto_increment,
  Grants_govTrackingNumber varchar(240) NOT NULL default '',
  FormVersionIdentifier varchar(30) default '',
  CostClassification varchar(100) default '',
  BudgetEstimatedCostAmount float default '0',
  BudgetNonAllowableCostAmount float default '0',
  BudgetTotalAllowableCostAmount float default '0',
  PRIMARY KEY  (BudgetInfoIndex)
) TYPE=MyISAM;

--
-- Dumping data for table 'sf424c_budgetinfo'
--


--
-- Table structure for table 'sf424c_federalfunding'
--

CREATE TABLE sf424c_federalfunding (
  FederalFundingINdex int(11) NOT NULL auto_increment,
  Grants_govTrackingNumber varchar(240) NOT NULL default '',
  FormVersionIdentifier varchar(30) default '',
  FederalFundingPercentageShareValue int(11) default '0',
  FederalFundingShareValue float default '0',
  PRIMARY KEY  (FederalFundingINdex)
) TYPE=MyISAM;

--
-- Dumping data for table 'sf424c_federalfunding'
--


--
-- Table structure for table 'sf424cover'
--

CREATE TABLE sf424cover (
  Grants_govTrackingNumber varchar(240) NOT NULL default '',
  AuthorizedRepresentativeSignature varchar(144) default '',
  SignedDate date default '0000-00-00',
  AgencySchemaVersion varchar(10) default '',
  FromVersionIdentifier varchar(30) default '',
  SubmissionTypeCode varchar(100) default '',
  SubmittedDate date default '0000-00-00',
  ApplicationTypeCode varchar(100) default '',
  AgencyName varchar(60) default '',
  AgencyReceivedDate date default '0000-00-00',
  StateReceivedDate date default '0000-00-00',
  StateID varchar(30) default '',
  FederalID varchar(30) default '',
  CFDANumber varchar(15) default '',
  ActivityTitle varchar(120) default '',
  Assurance tinyint(1) default '0',
  StateReviewCode varchar(100) default '',
  StateReviewDate date default '0000-00-00',
  RevisionCode1 varchar(100) default '',
  RevisionCode2 varchar(100) default '',
  RevisionOtherExplanation varchar(45) default '',
  ApplicantID varchar(30) default '',
  ApplicantTypeCode varchar(100) default '',
  ApplicantTypeCodeOtherExplanation varchar(50) default '',
  OrganizationName varchar(120) default '',
  DUNSID varchar(13) default '',
  DepartmentName varchar(30) default '',
  DivisionName varchar(30) default '',
  EmployerID varchar(30) default '',
  Street varchar(110) default '',
  City varchar(35) default '',
  County varchar(30) default '',
  StateCode char(2) default '',
  ZipCode varchar(15) default '',
  Country char(3) default '',
  DelinquentFederalDebtIndicator tinyint(1) default '0',
  DelinquentFederalDebtExplanation longtext,
  OrganizationCongressionalDistrict varchar(30) default '',
  ProjectTitle varchar(200) default '',
  Location varchar(45) default '',
  ProposedStartDate date default '0000-00-00',
  ProposedEndDate date default '0000-00-00',
  ProjectCongressionalDistrict varchar(30) default '',
  FederalEstimatedAmount float default '0',
  ApplicantEstimatedAmount float default '0',
  StateEstimatedAmount float default '0',
  LocalEstimatedAmount float default '0',
  OtherEstimatedAmount float default '0',
  ProgramIncomeEstimatedAmount float default '0',
  TotalEstimatedAmount float default '0',
  ApplicantNamePrefix varchar(10) default '',
  ApplicantGivenName1 varchar(35) default '',
  ApplicantGivenName2 varchar(25) default '',
  ApplicantFamilyName varchar(60) default '',
  ApplicantNameSuffix varchar(10) default '',
  ApplicantTelephoneNumber varchar(25) default '',
  ApplicantFaxNumber varchar(25) default '',
  ApplicantEmail varchar(80) default '',
  AORNamePrefix varchar(10) default '',
  AORGivenName1 varchar(35) default '',
  AORGivenName2 varchar(25) default '',
  AORFamilyName varchar(60) default '',
  AORNameSuffix varchar(10) default '',
  AORTelephoneNumber varchar(4) default '',
  AgencyTrackingNumber varchar(240) default '',
  RepresentativeTitle varchar(45) default '',
  PRIMARY KEY  (Grants_govTrackingNumber)
) TYPE=MyISAM;

--
-- Dumping data for table 'sf424cover'
--


--
-- Table structure for table 'sf424d'
--

CREATE TABLE sf424d (
  TableIndex int(11) NOT NULL auto_increment,
  Grants_govTrackingNumber varchar(240) NOT NULL default '',
  FormVersionIdentifier varchar(30) default '',
  RepresentativeName varchar(30) default '',
  RepresentativeTitle varchar(45) default '',
  ApplicantOrganizationName varchar(60) default '',
  SubmittedDate date default '0000-00-00',
  ProgramType varchar(100) default '',
  PRIMARY KEY  (TableIndex)
) TYPE=MyISAM;

--
-- Dumping data for table 'sf424d'
--


--
-- Table structure for table 'sf424footer'
--

CREATE TABLE sf424footer (
  Grants_govTrackingNumber varchar(240) NOT NULL default '',
  ReceivedDateTime datetime default '0000-00-00 00:00:00',
  SubmitterName varchar(240) default '',
  HashValue blob,
  HashAlgorithm varchar(100) default '',
  SchemaVersion varchar(10) NOT NULL default '1.0',
  PRIMARY KEY  (Grants_govTrackingNumber)
) TYPE=MyISAM;

--
-- Dumping data for table 'sf424footer'
--


--
-- Table structure for table 'sf424header'
--

CREATE TABLE sf424header (
  Grants_govTrackingNumber varchar(240) NOT NULL default '',
  AgencyName varchar(60) default '',
  CFDANumber varchar(15) default '',
  ActivityTitle varchar(120) default '',
  OpportunityID varchar(100) default '',
  OpportunityTitle varchar(255) default '',
  CompetitionID varchar(100) default '',
  OpeningDate date default '0000-00-00',
  ClosingDate date default '0000-00-00',
  SubmissionTitle varchar(240) default '',
  HashValue blob,
  HashAlgorithm varchar(100) default '',
  SchemaVersion varchar(100) NOT NULL default '1.0',
  PRIMARY KEY  (Grants_govTrackingNumber)
) TYPE=MyISAM;

--
-- Dumping data for table 'sf424header'
--


